import traceback

from cpl_core.configuration.configuration_model_abc import ConfigurationModelABC
from cpl_core.console import Console


class ServerSettings(ConfigurationModelABC):

    def __init__(self):
        ConfigurationModelABC.__init__(self)

        self._id: int = 0
        self._message_delete_timer: int = 0
        self._login_message_channel_id: int = 0
        self._login_message: str = ''

    @property
    def id(self) -> str:
        return self._id
    
    @property
    def message_delete_timer(self) -> int:
        return self._message_delete_timer
    
    @property
    def login_message_channel_id(self) -> int:
        return self._login_message_channel_id
    
    @property
    def login_message(self) -> str:
        return self._login_message

    def from_dict(self, settings: dict):
        try:
            self._id = int(settings['Id'])
            self._message_delete_timer = int(settings['MessageDeleteTimer'])
            self._login_message_channel_id = int(settings['LoginMessageChannelId'])
            self._login_message = settings['LoginMessage']
        except Exception as e:
            Console.error(f'[ ERROR ] [ {__name__} ]: Reading error in settings')
            Console.error(f'[ EXCEPTION ] [ {__name__} ]: {e} -> {traceback.format_exc()}')
